﻿using MidiDotNet;
using Mvvm;

namespace Byond.Standalone.ViewModels
{
	internal class MidiDeviceViewModel : ViewModelBase
	{
		public static readonly MidiDeviceViewModel None;

		static MidiDeviceViewModel()
		{
			None = new MidiDeviceViewModel(null);
		}

		public MidiDeviceViewModel(DeviceBase device)
		{
			Device = device;
		}

		public DeviceBase Device { get; private set; }

		public string DeviceName { get { return ToString(); } }

		public override string ToString()
		{
			return Device == null ? "-- none --" : Device.Name;
		}
	}
}