// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

using Jacobi.Vst.Core;
using Jacobi.Vst.Framework.Plugin;

namespace Byond.Vst
{
	sealed class PluginAudioProcessor : VstPluginAudioProcessorBase
	{
		// TODO: Channels Input Output
		public PluginAudioProcessor(
			ByondPluginInfo pluginInfo,
			VstAudioEngine engine)
			: base(pluginInfo.AudioInputCount, pluginInfo.AudioOutputCount, 0)
		{
			_engine = engine;
		}

		private readonly VstAudioEngine _engine;

		public override void Process(VstAudioBuffer[] inChannels, VstAudioBuffer[] outChannels)
		{
			_engine.SetBuffers(inChannels, outChannels);
			_engine.PrepareCycle(outChannels[0].SampleCount);
			_engine.ProcessAudio();

			// buffers mit 0 fllen, sonst gibt es Wiederholungen
			if (!_engine.IsRunning)
			{
				foreach (var outChannel in outChannels)
				{
					for (var i = 0; i < outChannel.SampleCount; i++)
						outChannel[i] = 0;
				}
			}
		}

		//public override void Process(
		//    VstAudioPrecisionBuffer[] inChannels,
		//    VstAudioPrecisionBuffer[] outChannels)
		//{
		//    _engine.SetBuffers(inChannels, outChannels);
		//    _engine.PrepareCycle(outChannels[0].SampleCount);
		//    _engine.ProcessAudio();
		//}
	}
}