// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System.Collections.Generic;
using System.Linq;

namespace Byond.EnsembleLibrary
{
	public class LibraryFolder : LibraryItem
	{
		public LibraryFolder(
			string path,
			IEnumerable<LibraryItem> items,
			IEnumerable<LibraryFolder> folders)
			: base(path)
		{
			Items = items;

			Folders = folders;
			foreach (var child in Folders)
				child.Parent = this;

			MeAndDescendantFolders = new[] { this }
				.Concat(folders.SelectMany(it => it.MeAndDescendantFolders))
				.ToList();
		}

		public LibraryFolder Parent { get; private set; }
		public IEnumerable<LibraryFolder> Folders { get; private set; }
		public IEnumerable<LibraryItem> Items { get; private set; }
		public IEnumerable<LibraryFolder> MeAndDescendantFolders { get; private set; }
	}
}