// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;
using Mvvm;
using Byond.Messages;
using Utils.Messaging;

namespace Byond.EnsembleLibrary.ViewModels
{
	public class BreadcrumpViewModel : ViewModelBase
	{
		private readonly LibraryFolder _libraryFolder;
		private readonly Action<string> _showFolder;

		public BreadcrumpViewModel(
			LibraryFolder libraryFolder, 
			string displayName,
			Action<string> showFolder)
		{
			_libraryFolder = libraryFolder;
			_showFolder = showFolder;
			DisplayName = displayName;
		}

		public string DisplayName { get; private set; }

		public void Select()
		{
			_showFolder(_libraryFolder.Path);
		}
	}
}