// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Collections.Generic;
using System.Linq;
using Mvvm;
using Byond.Messages;
using Utils.Messaging;

namespace Byond.EnsembleLibrary.ViewModels
{
	public class FolderViewModel : ViewModelBase
	{
		private readonly Action<string> _selectFolder;

		public FolderViewModel(
			LibraryFolder libraryFolder,
			IEnumerable<ItemViewModel> items,
			IEnumerable<FolderViewModel> folders,
			Action<string> selectFolder)
		{
			_selectFolder = selectFolder;
			_libraryFolder = libraryFolder;
			Folders = folders;
			Items = items.ToList();
		}

		private readonly LibraryFolder _libraryFolder;

		public string FolderName { get { return _libraryFolder.Name; } }
		public IEnumerable<ItemViewModel> Items { get; private set; }
		public IEnumerable<FolderViewModel> Folders { get; private set; }
		public string Path { get { return _libraryFolder.Path; } }

		public void Select()
		{
			_selectFolder(_libraryFolder.Path);
		}
	}
}