﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System.Xml.Linq;

namespace Byond
{
	class EnsembleSerializer
	{
		#region Serialization

		public void Serialize(Ensemble ensemble, string fileName)
		{
			var document = ToXml(ensemble);
			document.Save(fileName);
		}

		private XDocument ToXml(Ensemble ensemble)
		{
			var document = new XDocument();
			document.Add(
				new XElement("Ensemble",
					new XElement("PatchCode", ensemble.PatchCode),
					new XElement("UiCode", ensemble.UiCode)));
			return document;
		}

		#endregion

		#region Deserialization

		public void Deserialize(Ensemble ensemble)
		{
			var xDocument = XDocument.Load(ensemble.FileName).Root;
			ToEnsemble(xDocument, ensemble);
		}

		private void ToEnsemble(XElement xDocument, Ensemble ensemble)
		{
			ensemble.PatchCode = xDocument.GetElementValue("PatchCode");
			ensemble.UiCode = xDocument.GetElementValue("UiCode");
		}

		#endregion
	}
}
