﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace Byond
{
	public class Env
	{
		public Env()
		{
#if DEBUG
			RootPath = Path.GetFullPath(
				Path.GetDirectoryName(GetType().Assembly.Location) +
				"\\..\\..\\..\\..\\_byondUserFolder");
#else
			RootPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) 
				+ "\\Byond";
#endif

			PatchPath = Path.Combine(RootPath, "Patches");
			AssemblyPath = Path.Combine(RootPath, "Assemblies");
			RecordingsPath = Path.Combine(RootPath, "Recordings");
		}

		public string RootPath { get; private set; }
		public string PatchPath { get; private set; }
		public string AssemblyPath { get; private set; }
		public string RecordingsPath { get; private set; }
	}
}
