﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;
using Utils.Documentation;

namespace Byond.HostObjects
{
	[Doc]
	public abstract class CallbackControl
	{
		// TODO: Geht nicht, solange keine Filterung deklarativ gemacht werden kann
		//internal bool IsOneTime { get; private set; }
		internal bool StopRequest { get; private set; }

		[Doc]
		public virtual void Stop()
		{
			StopRequest = true;
		}

		// TODO: Geht nicht, solange keine Filterung deklarativ gemacht werden kann
		//public CallbackControl OneTime()
		//{
		//    IsOneTime = true;
		//    return this;
		//}
	}
	
	public sealed class CallbackControl<T> : CallbackControl
	{
		private readonly Action<T, CallbackControl> _callback;

		internal CallbackControl(Action<T, CallbackControl> callback)
		{
			_callback = callback;
		}

		internal void Raise(T arg)
		{
			_callback(arg, this);
		}
	}
}