// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;

namespace Byond.HostObjects
{
	sealed class CallbackController : CallbackController<object>
	{
		public CallbackControl Register(Action<CallbackControl> callback)
		{
			AssertCallback(callback);
			return Register((o, c) => callback(c));
		}

		public CallbackControl Register(Action callback)
		{
			// TODO: Hier knnen Exceptions kommen, die vom Skript ausgelst wqerden!
			// IMP: Das muss bercksichtigt werden und das Ens gestoppt werden.
			AssertCallback(callback);
			return Register(c => callback());
		}

		public void Raise()
		{
			Raise(null);
		}

		private void AssertCallback(object callback)
		{
			if (callback == null)
				throw new Exception("Callback must not be null!");
		}
	}
}