﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using Byond.AudioMidi;

namespace Byond.HostObjects
{
	sealed class PatchInfo
	{
		public PatchInfo(IAudioInfo audioInfo)
		{
			Pos = new Position(0, 0);
			
			// Die Werte werden _einmal_ umgeladen, damit sie in der
			// Ctor-Methode des Patches zur Verfügung stehen. Danach
			// werden sie von der AudioEngine gepusht (Performance).
			SampleRate = audioInfo.SampleRate;
			SamplePos = audioInfo.SamplePosition;
			SongTempo = audioInfo.SongTempo;
			IsPlaying = audioInfo.IsTransportPlaying;
		}

		public double SongTempo { get; set; }
		public double SampleRate { get; set; }
		public bool IsPlaying { get; set; }
		public bool PlayingStateChanged { get; set; }
		public double Ppq { get; set; }
		public double NextPpq { get; set; }
		public double SamplePos { get; set; }
		public Position Pos { get; set; }
	}
}