﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.IO;
using Byond.EnsembleLibrary;

namespace Byond
{
	class Include
	{
		public Include(string include, string parentFileName, string libraryPath)
		{
			if (include.StartsWith("\\"))
			{
				include = libraryPath + include;
			}
			else
			{
				include = Path.Combine(Path.GetDirectoryName(parentFileName), include);
			}

			FullFileName = include + Library.PatchFileExtension;
			ClassName = FullFileName.GetClassName();
			Namespace = FullFileName.GetNameSpace(libraryPath);
		}

		public string FullFileName { get; private set; }
		public string ClassName { get; private set; }
		public string Namespace { get; private set; }

		#region Equals

		// override object.Equals
		public override bool Equals(object obj)
		{
			return obj != null 
				&& GetType() == obj.GetType()
				&& ((Include)obj).FullFileName == FullFileName;
		}

		// override object.GetHashCode
		public override int GetHashCode()
		{
			return FullFileName.GetHashCode();
		}

		#endregion
	}
}
