﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System.Windows;
using System.Windows.Controls;
using System.Windows.Markup;
using Byond.UIRuntime;
using Utils.Documentation;

namespace Byond.PatchUiControls
{
	[Doc]
	[ContentProperty("Text")]
	public class Label : UiControl
	{
		static Label()
		{
			DefaultStyleKeyProperty.OverrideMetadata(
				typeof(Label),
				new FrameworkPropertyMetadata(typeof(Label)));
		}

		public Label()
		{
			VerticalAlignment = VerticalAlignment.Center;
			HorizontalAlignment = HorizontalAlignment.Center;
		}

		#region Text DP

		public static readonly DependencyProperty TextProperty =
			DependencyProperty.Register(
				"Text", typeof(string), typeof(Label),
				new PropertyMetadata(default(string)));

		[Doc]
		public string Text
		{
			get { return (string)GetValue(TextProperty); }
			set { SetValue(TextProperty, value); }
		}

		#endregion
	}
}
