// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System.Windows;
using System.Windows.Controls;
using Utils.Documentation;

namespace Byond.PatchUiControls
{
	[Doc]
	public class PatchPanel : Control
	{
		static PatchPanel()
		{
			DefaultStyleKeyProperty.OverrideMetadata(
				typeof(PatchPanel),
				new FrameworkPropertyMetadata(typeof(PatchPanel)));
		}

		[Doc]
		public string Path { get; set; }

		#region PatchControl

		public Control PatchControl
		{
			get { return (Control)GetValue(PatchControlProperty); }
			set { SetValue(PatchControlProperty, value); }
		}

		// Using a DependencyProperty as the backing store for PatchControl.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty PatchControlProperty =
			DependencyProperty.Register("PatchControl", typeof(Control), typeof(PatchPanel), new UIPropertyMetadata(null));

		#endregion
	}
}