// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

using System.Windows.Input;
using Byond.UIRuntime;
using Utils.Documentation;

namespace Byond.PatchUiControls
{
	[Doc]
	public class ToggleButton : ButtonBase
	{
		[Doc]
		public string GroupName { get; set; }

		protected override void OnIsCheckedChanged()
		{
			if (!IsChecked)
				return;
			
			var anchor = this.FindParentOfType<IToggleButtonAnchor>();
			if (anchor != null)
				anchor.DisableGroup(this, GroupName);
		}

		protected override void OnPreviewMouseLeftButtonDown(MouseButtonEventArgs e)
		{
			CanBindFrom = false;
			CaptureMouse();
			IsChecked = !IsChecked;
			WasChangedByUser = true;
			e.Handled = true;
		}

		protected override void OnPreviewMouseLeftButtonUp(MouseButtonEventArgs e)
		{
			CanBindFrom = true;
			ReleaseMouseCapture();
			e.Handled = true;
		}
	}
}
