﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using Utils.Messaging;

namespace Byond.Shell
{
	public class MenuItemRegistrar
	{
		public event MessageEventHandler SendMessage;

		private readonly List<Func<UIElement>> _menuItems = new List<Func<UIElement>>();
		public IEnumerable<Func<UIElement>> MenuItems { get { return _menuItems.ToList(); } }

		public void RegisterItem(Func<UIElement> menuItem)
		{
			_menuItems.Add(menuItem);
		}
	}
}
