﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System.Windows;
using System.Windows.Media;

namespace Byond.Shell.Themes
{
	public static class ImageButtonExtensions
	{
		#region ImageSource

		public static ImageSource GetIconSource(DependencyObject obj)
		{
			return (ImageSource)obj.GetValue(IconSourceProperty);
		}

		public static void SetIconSource(DependencyObject obj, ImageSource value)
		{
			obj.SetValue(IconSourceProperty, value);
		}

		public static readonly DependencyProperty IconSourceProperty =
			DependencyProperty.RegisterAttached("IconSource", typeof(ImageSource), typeof(ImageButtonExtensions), new UIPropertyMetadata(null));

		#endregion

		#region IconSize

		public static IconSize GetIconSize(DependencyObject obj)
		{
			return (IconSize)obj.GetValue(IconSizeProperty);
		}

		public static void SetIconSize(DependencyObject obj, IconSize value)
		{
			obj.SetValue(IconSizeProperty, value);
		}

		// Using a DependencyProperty as the backing store for IconSize.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty IconSizeProperty =
			DependencyProperty.RegisterAttached("IconSize", typeof(IconSize), typeof(ImageButtonExtensions), new UIPropertyMetadata(IconSize.Medium));

		#endregion
	}

	public enum IconSize
	{
		XSmall,
		Small,
		Medium,
		Large
	}
}
