﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System.Linq;
using Byond.HostObjects;

namespace Byond
{
	sealed class VoiceManager
	{
		// TODO: Könnte man auch mit CallbackController machen
		private Voice[] _voices = new Voice[0];
		private Voice _currentVoice;

		// Das ganze Voicing (auch im Patch) mit CallbackController machen
		public void ProcessVoices()
		{
			var voices = _voices;
			foreach (var voice in voices)
			{
				_currentVoice = voice;
				voice.Process();
			}

			_currentVoice = null;
		}

		public int VoicesCount { get { return _voices.Length; } }

		public bool EnableVoiceProcessing { get; set; }

		internal void AddVoice(Voice voice)
		{
			if (_currentVoice != null)
				_currentVoice.Children.Add(voice);
			_voices = _voices.Add(voice);
		}

		internal void RemoveVoice(Voice voice)
		{
			_voices = _voices.Remove(voice);
			foreach (var it in voice.Children.Where(it => it.StopWhenParentStops))
				RemoveVoice(it);
		}
	}
}
