// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System.Linq;
using System.Windows;
using Utils;

namespace Mvvm.Bindings
{
	class CanToEnabledBinding : ViewBinding
	{
		public override void SetupView(ViewFactory viewFactory, FrameworkElement view, object viewModel)
		{
			viewModel.GetType().GetProperties()
				.Where(it => it.Name.StartsWith("Can"))
				.Select(it => new
					{
						FrameworkElement = view.FindName(it.Name.Remove(0, 3)) as FrameworkElement,
						Property = it
					})
				.Where(it => it.FrameworkElement != null)
				.Where(it => it.FrameworkElement.GetBindingExpression(UIElement.IsEnabledProperty) == null)
				.ForEach(it => it.FrameworkElement.SetBinding(UIElement.IsEnabledProperty, it.Property.Name));
		}
	}
}