// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;

namespace Mvvm.Bindings
{
	class ContentBinding : ViewBinding
	{
		public override void SetupView(ViewFactory viewFactory, FrameworkElement view, object viewModel)
		{
			viewModel.GetType().GetProperties()
				.Where(
					it =>
						!(it.PropertyType.IsPrimitive || it.PropertyType.IsValueType ||
							it.PropertyType == typeof (string)))
				.Select(it => new
					{
						ContentControl = view.FindName(it.Name).AsExactly<ContentControl>(),
						Property = it
					})
				.Where(it => it.ContentControl != null)
				.Where(it => it.ContentControl.GetBindingExpression(ContentControl.ContentProperty) == null)
				.ForEach(it =>
					{
						var binding = new Binding(it.Property.Name)
							{
								Converter = new MvvmConverter(viewFactory)
							};
						it.ContentControl.SetBinding(ContentControl.ContentProperty, binding);
					});
		}

		//public override void SetupView(ViewFactory viewFactory, FrameworkElement view, object viewModel)
		//{
		//    viewModel.GetType().GetProperties()
		//        .Where(it => !(it.PropertyType.IsPrimitive || it.PropertyType.IsValueType || it.PropertyType == typeof(string)))
		//        .Select(it => new
		//            {
		//                ContentControl = view.FindName(it.Name).AsExactly<ContentControl>(),
		//                Property = it
		//            })
		//        .Where(it => it.ContentControl != null)
		//        .OnPropertyChanged(
		//            it => it.Property.Name,
		//            viewModel,
		//            it =>
		//                {
		//                    var propertyValue = it.Property.GetValue(viewModel, null);
		//                    if (propertyValue == null) 
		//                        return;
		//                    it.ContentControl.Content = viewFactory.GetViewForModel(propertyValue);
		//                });
		//}
	}
}