﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Windows;

namespace Utils.DialogManagement
{
	public interface IDialog
	{
		DialogMode Mode { get; }
		DialogResultState Result { get; set; }
		DialogCloseBehavior CloseBehavior { get; set; }

		Action Ok { get; set; }
		Action Cancel { get; set; }
		Action Yes { get; set; }
		Action No { get; set; }

		bool CanOk { get; set; }
		bool CanCancel { get; set; }
		bool CanYes { get; set; }
		bool CanNo { get; set; }

		string OkText { get; set; }
		string CancelText { get; set; }
		string YesText { get; set; }
		string NoText { get; set; }

		string Caption { get; set; }

		VerticalAlignment VerticalDialogAlignment { set; }
		HorizontalAlignment HorizontalDialogAlignment { set; }

		void Show();
		void Close();
	}
}