﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
namespace Utils.DialogManagement
{
	public interface IDialogManager
	{
		IMessageDialog CreateMessageDialog(string message, DialogMode dialogMode);
		IMessageDialog CreateMessageDialog(string message, string caption, DialogMode dialogMode);

		ICustomContentDialog CreateCustomContentDialog(object content, DialogMode dialogMode);
		ICustomContentDialog CreateCustomContentDialog(object content, string caption, DialogMode dialogMode);

		IProgressDialog CreateProgressDialog(DialogMode dialogMode);
		IProgressDialog CreateProgressDialog(string message, DialogMode dialogMode);
		IProgressDialog CreateProgressDialog(string message, string readyMessage, DialogMode dialogMode);

		IWaitDialog CreateWaitDialog(DialogMode dialogMode);
		IWaitDialog CreateWaitDialog(string message, DialogMode dialogMode);
		IWaitDialog CreateWaitDialog(string message, string readyMessage, DialogMode dialogMode);
	}
}