﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System.Windows;
using System.Windows.Controls;
using System.Windows.Threading;

namespace Utils.DialogManagement
{
	public class MessageDialog : DialogBase, IMessageDialog
	{
		public MessageDialog(
			IDialogHost dialogHost, 
			DialogMode dialogMode,
			string message,
			Dispatcher dispatcher)
			: base(dialogHost, dialogMode, dispatcher)
		{
			InvokeUICall(() =>
				{
					_messageDialogControl = new MessageDialogControl(message);
					SetContent(_messageDialogControl);
				});
		}

		private MessageDialogControl _messageDialogControl;

		#region Implementation of IMessageDialog

		public string Message
		{
			get
			{
				var text = string.Empty;
				InvokeUICall(
					() => text = _messageDialogControl.Message);
				return text;
			}
			set
			{
				InvokeUICall(
					() => _messageDialogControl.Message = value);
			}
		}

		#endregion
	}
}