﻿using System.Windows;
using System.Windows.Controls;

namespace Utils.DialogManagement
{
	/// <summary>
	/// Interaction logic for MessageDialogControl.xaml
	/// </summary>
	public partial class MessageDialogControl
	{
		public MessageDialogControl(string message)
		{
			DataContext = this;
			Message = message;
			InitializeComponent();
		}

		#region Message DP

		public string Message
		{
			get { return (string)GetValue(MessageProperty); }
			set { SetValue(MessageProperty, value); }
		}

		// Using a DependencyProperty as the backing store for Message.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty MessageProperty =
			DependencyProperty.Register("Message", typeof(string), typeof(MessageDialogControl), new UIPropertyMetadata(string.Empty));

		#endregion
	}
}
