﻿// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;

namespace Utils.Messaging
{
	static class Extensions
	{
		public static IEnumerable<EventInfo> GetAllEvents(this object that)
		{
			return that.GetType().GetAllEvents();
		}
		
		public static IEnumerable<EventInfo> GetAllEvents(this Type type)
		{
			// get all events, also from inherited members
			var events = type.GetEvents(BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance);
			return type.BaseType == null
				? events.ToList()
				: events.Concat(type.BaseType.GetAllEvents()).ToList();
		}
	}
}
