// Copyright 2013 Ronald Schlenker, www.technewlogic.de.
// 
// This file is part of Byond.
// 
// GraphIT is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
// 
// Foobar is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
using System;

namespace Utils
{
	public class WeakReference<T> where T : class
	{
		public WeakReference(T target)
		{
			_weakReference = new WeakReference(target);
		}

		public WeakReference(T target, bool trackResurrection)
		{
			_weakReference = new WeakReference(target, trackResurrection);
		}

		private readonly WeakReference _weakReference;

		public T Target
		{
			get
			{
				var target = _weakReference.Target;
				return target != null 
					? (T) target 
					: null;
			}
		}
	}
}
