using System;
using System.Windows.Input;

namespace Byond.Vst.GlobalKeyLogger
{
	/// <summary>
	/// Raw KeyEvent arguments.
	/// </summary>
	public class RawKeyEventArgs : EventArgs
	{
		/// <summary>
		/// VKCode of the key.
		/// </summary>
		public int VKCode;

		/// <summary>
		/// WPF Key of the key.
		/// </summary>
		public Key Key;

		/// <summary>
		/// Is the hitted key system key.
		/// </summary>
		public bool IsSysKey;

		/// <summary>
		/// Create raw keyevent arguments.
		/// </summary>
		/// <param name="VKCode"></param>
		/// <param name="isSysKey"></param>
		public RawKeyEventArgs(int VKCode, bool isSysKey)
		{
			this.VKCode = VKCode;
			IsSysKey = isSysKey;
			Key = KeyInterop.KeyFromVirtualKey(VKCode);
		}
	}
}